package com.anrenmind.filemd5;

import com.facebook.react.bridge.Callback;
import com.facebook.react.bridge.ReactApplicationContext;
import com.facebook.react.bridge.ReactContext;
import com.facebook.react.bridge.ReactContextBaseJavaModule;
import com.facebook.react.bridge.ReactMethod;
import com.facebook.react.bridge.WritableMap;
import com.facebook.react.bridge.WritableNativeMap;

import java.io.File;
import java.io.FileInputStream;
import java.math.BigInteger;
import java.security.MessageDigest;

/**
 * Created by lcg on 16/9/19.
 */

public class FileMD5Module extends ReactContextBaseJavaModule {

    public FileMD5Module(ReactApplicationContext reactContext){
        super(reactContext);

    }

    @Override
    public String getName() {
        return "FileMD5";
    }

    @ReactMethod
    public void getFileMD5(String filepath, final Callback callback){
        File file = new File(filepath);
        if (file == null || !file.exists() || !file.isFile()){
            WritableMap error = new WritableNativeMap();
            error.putInt("code",-1);
            error.putString("msg","filepath is not exist or is not file.");
            callback.invoke(error);
        }

        MessageDigest digest = null;
        FileInputStream inputStream = null;

        byte buffer[] = new byte[1024];
        int len = 0;
        try {
            digest = MessageDigest.getInstance("MD5");
            inputStream = new FileInputStream(file);
            while ((len = inputStream.read(buffer,0,1024)) != -1){
                digest.update(buffer,0,len);
            }

            inputStream.close();
        }
        catch (Exception e){
            e.printStackTrace();
            WritableMap error = new WritableNativeMap();
            error.putInt("code",-2);
            error.putString("msg","calculate file md5 failed.");
            callback.invoke(error);
        }

        BigInteger bigInteger = new BigInteger(1,digest.digest());

        callback.invoke(null,bigInteger.toString(16));
    }

}
