//
//  RCTFileMD5.m
//  RCTFileMD5
//
//  Created by lcg on 16/9/19.
//  Copyright © 2016年 Anren. All rights reserved.
//

#import "RCTFileMD5.h"
#import <CommonCrypto/CommonDigest.h>

@implementation RCTFileMD5

RCT_EXPORT_MODULE()

RCT_EXPORT_METHOD(getFileMD5:(NSString*)filepath callback:(RCTResponseSenderBlock)callback)
{
    NSFileHandle *file = [NSFileHandle fileHandleForReadingAtPath:filepath];
    if(!file)
    {
        callback(@[@{@"code": [NSNumber numberWithInt:-1],@"msg":@"filepath is not exist or is not file."}]);
        return ;
    }
    
    CC_MD5_CTX md5;
    CC_MD5_Init(&md5);
    
    while(YES)
    {
        NSData *buffer = [file readDataOfLength:1024];
        CC_MD5_Update(&md5, [buffer bytes], (CC_LONG)buffer.length);
        if([buffer length] == 0){
            break;
        }
    }
    
    unsigned char digest[CC_MD5_DIGEST_LENGTH] = {0};
    CC_MD5_Final(digest, &md5);
    
    NSString* md5String = [NSString stringWithFormat:
                   @"%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x",
                   digest[0], digest[1],
                   digest[2], digest[3],
                   digest[4], digest[5],
                   digest[6], digest[7],
                   digest[8], digest[9],
                   digest[10], digest[11],
                   digest[12], digest[13],
                   digest[14], digest[15]];
    
    callback(@[[NSNull null],md5String]);
}

@end
